'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _index = require('./index');

var styled = function styled(tag, cls) {
  var vars = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var content = arguments[3];

  return {
    cls: '.' + cls,
    functional: true,
    render: function render(h, context) {
      var getValue = function getValue(v) {
        return v && typeof v === 'function' ? v(context.props) : v.cls || v;
      };
      var className = (0, _index.css)(cls.map(getValue), vars.map(getValue), content);
      return h(tag, _extends({}, context.data, {
        class: [context.data.class, className]
      }), context.children);
    }
  };
};

exports.default = styled;